//*--------------------------------------------------------------------------------------
//
// m.s.joker@mtu-net.ru (Argussoft sample sources)
// phone +7 (495) 221 01 30
//
//*--------------------------------------------------------------------------------------
//* The software is delivered "AS IS" without warranty or condition of any
//* kind, either express, implied or statutory. This includes without
//* limitation any warranty or condition with respect to merchantability or
//* fitness for any particular purpose, or against the infringements of
//* intellectual property rights of others.
//*--------------------------------------------------------------------------------------

//#include "argussoft.h"
#include <stdio.h>
#include "math.h"
#include "board.h"
#include "dbgu.h"
#include "ssc.h"
#include "cdc_enumerate.h"
#include "argussoft.h"
#include "nokia_lcd.h"
#include "lib_twi.h"


//SAMPLEWORD AdcTxBuffer[8] =
//   { 0x8330,0x8730,0x8b30,0x8f30,0x8330,0x8730,0x8b30,0x8f30 };
unsigned short AdcTxBuffer[8] =
   //{ 0x8660,0x8e60,0x9660,0x9e60 };
  { 0x8b30,0x8f30,0x8330,0x8730,0x8330,0x8730,0x8b30,0x8f30 };



#define BL_OFF(pio) ((pio) & SW1)
#define BR_OFF(pio) ((pio) & SW2)
#define BU_OFF(pio) ((pio) & SW3)
#define BD_OFF(pio) ((pio) & SW4)

#define BL_ON(pio) (!BL_OFF(pio))
#define BR_ON(pio) (!BR_OFF(pio))
#define BU_ON(pio) (!BU_OFF(pio))
#define BD_ON(pio) (!BD_OFF(pio))

//#define AT91C_EEPROM_I2C_ADDRESS (0x4c<<16)

#define AT91C_EEPROM_I2C_ADDRESS (0x48<<16)

// twi debug message
volatile char message[80];
volatile int loop;

// m.s.joker@mtu-net.ru

#define RTTC_INTERRUPT_LEVEL            0

// ,   ,   

#define PIV_200_MS              186 // 16KHz

//#define USART_COM




//* external function

extern void Usart_init ( void );
extern void AT91F_US_Put( char *buffer);
extern void Trace_Toggel_LED( unsigned int led) ;


//*----------------------------------------------------------------------------
//* Function Name       : Periodic_Interval_Timer_handler
//* Object              : C handler interrupt function called by the interrupts
//*                       assembling routine
//*----------------------------------------------------------------------------

//   

void Periodic_Interval_Timer_handler(void)
{
    unsigned int status;
    static unsigned int page = 0;
    //   wav - 
    static unsigned int byte = 0x30; // skip wav - file header

    //* Interrupt Acknowledge
//    status = AT91C_BASE_PITC->PITC_PIVR;
//        status =status;
//   AT91C_BASE_DBGU->DBGU_THR = '*';
        //* Read the output state
//    if ((AT91F_PIO_GetInput(AT91C_BASE_PIOA) & LED1 ) == LED1 )   AT91F_PIO_ClearOutput( AT91C_BASE_PIOA, LED1 );
//      else  AT91F_PIO_SetOutput( AT91C_BASE_PIOA, LED1 );

  // set LDAC to 1-0-1
  //    LDAC,    

  AT91F_PIO_ClearOutput( AT91C_BASE_PIOA, LDAC ) ;
  AT91F_PIO_SetOutput( AT91C_BASE_PIOA, LDAC ) ;

  //         

  if(page==4096){page=0;};
  if(byte== 512){byte=0;page++;};

  //        

  SPI_Send(AT45_ReadByte(page,byte) << 4, DAC_CS, LAST_XFER);
  byte++;

  //   

  status = AT91C_BASE_PITC->PITC_PIVR;

  //   /

  status = status;

}

//*--------------------------------------------------------------------------------------
//* Function Name       : wait
//* Object              : Software waiting loop
//* Input Parameters    : none. Waiting time is defined by the global variable LedSpeed.
//* Output Parameters   : none
//*--------------------------------------------------------------------------------------
void wait ( void )
{//* Begin
	//Wait at least 10 ms before value is written into EEPROM
    for (loop=0; loop<10000; loop++){};

}//* End



//*----------------------------------------------------------------------------
//* \fn    AT91F_TestEEPROM
//* \brief test EEPROM
//*----------------------------------------------------------------------------
int AT91F_TestEEPROM(void){

	char write, read,status;
	//open the TWI
	AT91F_TWI_Open();

	write = 0x55;

	// Write a byte and read it
	 status =AT91F_TWI_WriteByte(AT91C_BASE_TWI, AT91C_EEPROM_I2C_ADDRESS | AT91C_TWI_IADRSZ_2_BYTE, 0x04, &write, 1);
	 if (status){
		  sprintf((char*) message,"Write Satus = %d\n\r",status);
		  AT91F_DBGU_Printk((char*)message);
     }
	// Wait 10 ms before data is written into EEPROM
       wait();

	status =AT91F_TWI_ReadByte(AT91C_BASE_TWI, AT91C_EEPROM_I2C_ADDRESS | AT91C_TWI_IADRSZ_2_BYTE, 0x04, &read, 1);
	 if (status){
		  sprintf((char*) message,"Read Satus = %d\n\r",status);
		  AT91F_DBGU_Printk((char*)message);
     }

	if (read == write){

		AT91F_DBGU_Printk("Test TWI OK\n\r");
                return 0;
	} else {

		AT91F_DBGU_Printk("Error during test\n\r");
                sprintf((char*) message,"Error during test write 0x%X and read 0x%X\n\r",write,read);
		AT91F_DBGU_Printk((char*)message);
                return -1;
	}

}




//  

int main ( void )
{
char Str[100];
unsigned char strnum = 0;
    //unsigned long i;

    AT91F_DBGU_Init();
    RESET_Init();



    // init onboard LEDS

    LEDS_Init();

    // LED1=ON

    AT91F_PIO_ClearOutput( AT91C_BASE_PIOA, LED1 ) ; // LED1=ON

    // init spi

    //SPI_Init();

//    USB_Init();
//    USB_Start();


    AT91F_DBGU_Printk("\n\r.  Argussoft DEMO March/2006)\n\r.  E-mail: m.s.joker@mtu-net.ru");

    // init SSC controller
//    SSC_Init();
    // get status
//    sprintf(Str,"SR=0x%x\n\r",SSC_GetStatus());AT91F_DBGU_Printk(Str);
    // send word
//    SSC_SendWord(0x8330);
//    AT91F_DBGU_Printk("word sended\n\r");
    // get status
//    sprintf(Str,"SR=0x%x\n\r",SSC_GetStatus());AT91F_DBGU_Printk(Str);
    // get received byte
//    sprintf(Str,"Received byte=0x%x\n\r",SSC_GetWord());AT91F_DBGU_Printk(Str);
    // get status
//    sprintf(Str,"SR=0x%x\n\r",SSC_GetStatus());AT91F_DBGU_Printk(Str);












/*
    adc = SSC_Transfer(0x8330);//start ADC conversion

    AT91F_DBGU_Printk("adc done \n\r");

    sprintf(Str,"Adc data: %x\n\r",adc);

    AT91F_DBGU_Printk("sprintf done \n\r");

    AT91F_DBGU_Printk(Str);

    AT91F_DBGU_Printk("printing from str done \n\r");

    adc = SSC_Transfer(0x8330);//start ADC conversion
    sprintf(Str,"Adc data: %x\n\r",adc);
    AT91F_DBGU_Printk(Str);

    adc = SSC_Transfer(0x8330);//start ADC conversion
    sprintf(Str,"Adc data: %x\n\r",adc);
    AT91F_DBGU_Printk(Str);
*/
    // init nokia lcd

    //AT91F_DBGU_Printk("\n\r.  try LCD init");
    LcdInit();
    AT91F_DBGU_Printk("\n\r.  LCD init done");

    LcdClear();
    //              0123456789abcde -----------
    LcdGotoXY(1,1);
    LcdStr(FONT_1X," Play music");
    LcdGotoXY(1,2);
    LcdStr(FONT_1X," DBGU->Flash");
    LcdGotoXY(1,3);
    LcdStr(FONT_1X," USB sample");
    LcdGotoXY(1,4);
    LcdStr(FONT_1X," ADC ext.");
    LcdGotoXY(1,5);
    LcdStr(FONT_1X," Termometer");
    LcdGotoXY(1,6);
    LcdStr(FONT_1X," Menu 6");
    LcdInvertStr(strnum);
    LcdUpdate();

    AT91F_DBGU_Printk("\n\r.  Please, select TEST option by pressing SW4(DOWN)/SW3(UP)");
    AT91F_DBGU_Printk("\n\r.  After selecting, press SW1 to start test");
    AT91F_DBGU_Printk("\n\r.  Don`t forget - connect TF & RF pins of AT91 chip for SSC test");
    AT91F_DBGU_Printk("\n\r.  0) Play wav file from flash (tsop28)");
    AT91F_DBGU_Printk("\n\r.  1) Transfer wav to flash via UART (XModem)");
    AT91F_DBGU_Printk("\n\r.  2) Start ATMEL BasicUSB app note");
    AT91F_DBGU_Printk("\n\r.  3) Start external ADC via SSC interface");
    AT91F_DBGU_Printk("\n\r.  4) Start termometer");
    AT91F_DBGU_Printk("\n\r.  5) reserved for future use\n\r");
    AT91F_DBGU_Printk(".  Press SW3/SW4 >0");


    // menu mode
    unsigned int pioStatus;

    AT91F_PIO_CfgInput(AT91C_BASE_PIOA, (SW1|SW2|SW3|SW4));
    LcdUpdate();//pause
    do
    {
      pioStatus = *AT91C_PIOA_PDSR;
      //if (BL_ON(pioStatus) && BR_OFF(pioStatus)) // check two buttons
      // up


      if (BL_ON(pioStatus) || BR_ON(pioStatus))
      {
        if (strnum == 0)//play music
        {
          SPI_Init();
          AT91F_DBGU_Printk(".  SPI init done\n\r");
          AT91F_DBGU_Printk(".  playing music now\n\r");
          // __start__ playing wav file from flash memory
          // until timer enabled, music is playing

          //* Init Real Time Timer
          //* Open Timer 0 interrupt
          AT91F_AIC_ConfigureIt ( AT91C_BASE_AIC, AT91C_ID_SYS, RTTC_INTERRUPT_LEVEL,AT91C_AIC_SRCTYPE_INT_LEVEL_SENSITIVE, Periodic_Interval_Timer_handler);
          // Set the interrupt mo
          AT91C_BASE_PITC->PITC_PIMR = AT91C_PITC_PITEN | AT91C_PITC_PITIEN | PIV_200_MS;  //  IRQ enable CPC
          //  RTTC_RTAR
          AT91F_AIC_EnableIt (AT91C_BASE_AIC, AT91C_ID_SYS);
          AT91F_DBGU_Printk("\n\r.  RTTC interrupt enabled");
          do{}while(1!=0); // 
        };

        if (strnum == 1)//xmodem
        {
          AT91F_DBGU_Printk(".  XModem started, reboot after sending\n\r");
          SPI_Init();
          XModem();
          do{}while(1!=0); // 
        };


        if (strnum == 2)//USB interface (Atmel example on PC)
        {
          USB_Start();
          AT91F_DBGU_Printk(".  USB test started\n\r");
        };


        if (strnum == 3)//SSC interface (external ADC)
        {
          AT91F_DBGU_Printk(".  ADC (SSC) test started\n\r");
          unsigned char i = 0;
          LcdClear();
          // init SSC controller
          SSC_Init();          // get status
          //sprintf(Str,"SR=0x%x\n\r",SSC_GetStatus());AT91F_DBGU_Printk(Str);
          // get status
          //sprintf(Str,"SR=0x%x\n\r",SSC_GetStatus());AT91F_DBGU_Printk(Str);
          // get received byte
          //sprintf(Str,"Received byte=0x%x\n\r",SSC_GetWord());AT91F_DBGU_Printk(Str);
          // get status
          //sprintf(Str,"SR=0x%x\n\r",SSC_GetStatus());AT91F_DBGU_Printk(Str);

          unsigned short num,a;
          unsigned char x,b;
          unsigned char prev[84];
          x = 0;
          do
          {
            //LcdLine(x,0,x,47,PIXEL_OFF);
            //LcdPixel(x,prev[x],PIXEL_OFF);
            for(i=0;i<4;i++)
            {
//              if(x==0){LcdClear();};
//              if(x==0)
//                {LcdPixel(83,prev[],PIXEL_OFF);}
//                else
//                {LcdPixel(x-1,prev[i],PIXEL_OFF);};
              num = SSC_Transfer((unsigned int)AdcTxBuffer[i]);
              //b = num / 86;
              //LcdPixel(x,b,PIXEL_ON);
              //prev[x] = b;
//              x++;
//              if(x>83){x=0;};
              sprintf(Str,"Ch.%1.1d=0x%4.4x",i,num);
//              AT91F_DBGU_Printk(Str);
//              LcdGotoXY(1,i+1);
              LcdGotoXY(1,i+1);
              LcdStr(FONT_1X,(byte*)Str);
              LcdUpdate();
            }
            //x++;
            //if(x>83){x=0;};
//            LcdGotoXY(1,i+1);
//            LcdStr(FONT_1X,"0123456789abcdef");

//for(a=0;a<1000;a++){sprintf(Str,"0x%x\n\r",a);};
            //for(a=0;a<10000;a++){sprintf(Str,"0x%x\n\r",a);};
          }


          while(1!=0); // 
        };

        if (strnum == 4)//TWI interface,temperature
        {
          AT91F_DBGU_Printk(".  Temperature (TWI) test started\n\r");
          unsigned int address,tmp,status;
          char write, read;
          char read2[2];
          LcdClear();
          AT91F_TWI_Open();
          //status = AT91F_TWI_WriteByte(AT91C_BASE_TWI, AT91C_EEPROM_I2C_ADDRESS | AT91C_TWI_IADRSZ_2_BYTE, address, &write, 1);
          do
          {
            status = AT91F_TWI_ReadByte(AT91C_BASE_TWI, AT91C_EEPROM_I2C_ADDRESS | AT91C_TWI_IADRSZ_1_BYTE,0, &read2[0], 2);
            //sprintf(Str,"T=%4.4d",((read2[0]<<2) | ((read2[1]>>6)&0x3))/4);
/*
sprintf(Str,"1byte=%2.2x",read2[0]);
            LcdGotoXY(1,1);
            LcdStr(FONT_1X,(byte*)Str);
sprintf(Str,"2byte=%2.2x",read2[1]);
            LcdGotoXY(1,2);
            LcdStr(FONT_1X,(byte*)Str);
            sprintf(Str,"T=%4.4d",((read2[0]<<2) | ((read2[1]>>6)&0x3))/4);
            LcdGotoXY(1,3);
            LcdStr(FONT_1X,(byte*)Str);


sprintf(Str,"1byte=%4.4x",read2[0]<<2);
            LcdGotoXY(1,4);
            LcdStr(FONT_1X,(byte*)Str);
sprintf(Str,"2byte=%4.4x",read2[1]>>6);
            LcdGotoXY(1,5);
            LcdStr(FONT_1X,(byte*)Str);
*/
            if(read2[1]>>6 == 0)
            {
              sprintf(Str,"T=%d.00",(read2[0]));
            }
            if(read2[1]>>6 == 1)
            {
              sprintf(Str,"T=%d.25",(read2[0]));
            }
            if(read2[1]>>6 == 2)
            {
              sprintf(Str,"T=%d.50",(read2[0]));
            }
            if(read2[1]>>6 == 3)
            {
              sprintf(Str,"T=%d.75",(read2[0]));
            }

            LcdGotoXY(1,6);
            LcdStr(FONT_1X,(byte*)Str);
            AT91F_DBGU_Printk(Str);
            AT91F_DBGU_Printk("\n\r");

            LcdUpdate();

          }while(1!=0);
        };







      };


      // up
      if (BU_ON(pioStatus))
      {
        // 3 times needed for delay

        LcdInvertStr(strnum);
        LcdUpdate();
        LcdInvertStr(strnum);
        LcdUpdate();
        LcdInvertStr(strnum);
        LcdUpdate();
        if (strnum == 0){strnum = 5;}else{strnum--;};
        LcdInvertStr(strnum);
        LcdUpdate();
        sprintf(Str,"%d",strnum);
        AT91F_DBGU_Printk(Str);
      };

      // down
      if (BD_ON(pioStatus))
      {

        // 3 times needed for delay

        LcdInvertStr(strnum);
        LcdUpdate();
        LcdInvertStr(strnum);
        LcdUpdate();
        LcdInvertStr(strnum);
        LcdUpdate();
        if (++strnum == 6){strnum = 0;};
        LcdInvertStr(strnum);
        LcdUpdate();
        sprintf(Str,"%d",strnum);
        AT91F_DBGU_Printk(Str);


      }

    }while(1);


        // 3 times needed for delay

/*
    for(i=0;i< 2*1024*1024;i++)
    {
      LcdGotoXY(1,6);
      LcdStr(FONT_1X,);
      LcdUpdate();
    };
*/


    //do{}while(1!=0); // 

/*
    AT91F_DBGU_Printk("\n\r.  LCD print done");

    XModem();



    // __start__ playing wav file from flash memory
    // until timer enabled, music is playing

        // Init Real Time Timer
        // Open Timer 0 interrupt
        AT91F_AIC_ConfigureIt ( AT91C_BASE_AIC, AT91C_ID_SYS, RTTC_INTERRUPT_LEVEL,AT91C_AIC_SRCTYPE_INT_LEVEL_SENSITIVE, Periodic_Interval_Timer_handler);
        // Set the interrupt mo
        AT91C_BASE_PITC->PITC_PIMR = AT91C_PITC_PITEN | AT91C_PITC_PITIEN | PIV_200_MS;  //  IRQ enable CPC
        //  RTTC_RTAR
        AT91F_AIC_EnableIt (AT91C_BASE_AIC, AT91C_ID_SYS);



do{}while(1!=0); // 
*/



//    

/*
// sinus on dacs

    //unsigned char sinus;
    double sinusfloat;
    unsigned int sinuscounter;
    double pointsperperiod;

    sinuscounter = 0;
    pointsperperiod = 2*3.1415926/100;

while (1)
{
//  sinus      = ((unsigned char)(128+127*sin(sinuscounter * pointsperperiod)));
  sinusfloat = (128+127*sin(sinuscounter * pointsperperiod));
  //sinusfloat = sin(sinuscounter * 2*3.14/100);
  //sinusfloat = cos(2*3.14);

  sinuscounter++;

  //mode = SPI->SPI_RDR;
//  while((SPI->SPI_SR & AT91C_SPI_TXEMPTY) == 0);
//  SPI->SPI_TDR = 0x01015555; // data = 0x5555, npcs1-active, close after tx (npcs = 1)
  SPI_Send(0x01010000 | (((unsigned char)sinusfloat) << 4) | (1 << 15), DAC_CS, LAST_XFER); // data = 0x5555, npcs1-active, close after tx (npcs = 1)
//  while((SPI->SPI_SR & AT91C_SPI_TXEMPTY) == 0);

  //mode = SPI->SPI_RDR;
//  while((SPI->SPI_SR & AT91C_SPI_TXEMPTY) == 0);
//  SPI->SPI_TDR = 0x01015555; // data = 0x5555, npcs1-active, close after tx (npcs = 1)
  SPI_Send(0x01010000 | (((unsigned char)sinusfloat) << 4) | (0 << 15), DAC_CS, LAST_XFER); // data = 0x5555, npcs1-active, close after tx (npcs = 1)
//  while((SPI->SPI_SR & AT91C_SPI_TXEMPTY) == 0);
  // set LDAC to 1-0-1
  AT91F_PIO_ClearOutput( AT91C_BASE_PIOA, LDAC ) ;
  AT91F_PIO_SetOutput( AT91C_BASE_PIOA, LDAC ) ;
};
*/


//    


/*
// saw to dac`s
unsigned char i,j;
i=0;j=0;
while (1)
{
//    AT91F_SPI_PutChar(SPI,0xaa55,0x00);
//    AT91F_SPI_PutChar(SPI,0xaa55,0x01);


  mode = SPI->SPI_RDR;
  while((SPI->SPI_SR & AT91C_SPI_TXEMPTY) == 0);
//  SPI->SPI_TDR = 0x01015555; // data = 0x5555, npcs1-active, close after tx (npcs = 1)
  SPI->SPI_TDR = 0x01010000 | (j << 4) | (1 << 15); // data = 0x5555, npcs1-active, close after tx (npcs = 1)
  while((SPI->SPI_SR & AT91C_SPI_TXEMPTY) == 0);

  mode = SPI->SPI_RDR;
  while((SPI->SPI_SR & AT91C_SPI_TXEMPTY) == 0);
//  SPI->SPI_TDR = 0x01015555; // data = 0x5555, npcs1-active, close after tx (npcs = 1)
  SPI->SPI_TDR = 0x01010000 | (i << 4) | (0 << 15); // data = 0x5555, npcs1-active, close after tx (npcs = 1)
  while((SPI->SPI_SR & AT91C_SPI_TXEMPTY) == 0);

//  i++;
//  j++;



  // set LDAC to 1-0-1
  AT91F_PIO_ClearOutput( AT91C_BASE_PIOA, LDAC ) ;
  AT91F_PIO_SetOutput( AT91C_BASE_PIOA, LDAC ) ;

  i++;
  j++;
};
*/


//     USB

/*
    while (1)
   {
        // Check enumeration
        if (pCDC.IsConfigured(&pCDC)) {
#ifndef USART_COM
        // Loop
           length = pCDC.Read(&pCDC, data, MSG_SIZE);
           pCDC.Write(&pCDC, data, length);
//         data[length]=0;
//         sprintf(message,"-I- Len %d: %s \n\r",length,data);
        // send char
//           AT91F_DBGU_Frame(message);
#else
        // Loop
          length = pCDC.Read(&pCDC, data, MSG_SIZE);
          data[length]=0;
          Trace_Toggel_LED( LED1) ;
          AT91F_US_Put(data);
#endif
        }
   }
*/
}


